package org.apache.bcel;

import org.apache.bcel.util.SyntheticRepository;
import java.io.IOException;
import org.apache.bcel.util.ClassPath;
import org.apache.bcel.classfile.JavaClass;

public abstract class Repository
{
    private static org.apache.bcel.util.Repository repository;
    
    public static JavaClass addClass(final JavaClass clazz) {
        final JavaClass old = Repository.repository.findClass(clazz.getClassName());
        Repository.repository.storeClass(clazz);
        return old;
    }
    
    public static void clearCache() {
        Repository.repository.clear();
    }
    
    public static JavaClass[] getInterfaces(final JavaClass clazz) throws ClassNotFoundException {
        return clazz.getAllInterfaces();
    }
    
    public static JavaClass[] getInterfaces(final String className) throws ClassNotFoundException {
        return getInterfaces(lookupClass(className));
    }
    
    public static org.apache.bcel.util.Repository getRepository() {
        return Repository.repository;
    }
    
    public static JavaClass[] getSuperClasses(final JavaClass clazz) throws ClassNotFoundException {
        return clazz.getSuperClasses();
    }
    
    public static JavaClass[] getSuperClasses(final String className) throws ClassNotFoundException {
        return getSuperClasses(lookupClass(className));
    }
    
    public static boolean implementationOf(final JavaClass clazz, final JavaClass inter) throws ClassNotFoundException {
        return clazz.implementationOf(inter);
    }
    
    public static boolean implementationOf(final JavaClass clazz, final String inter) throws ClassNotFoundException {
        return implementationOf(clazz, lookupClass(inter));
    }
    
    public static boolean implementationOf(final String clazz, final JavaClass inter) throws ClassNotFoundException {
        return implementationOf(lookupClass(clazz), inter);
    }
    
    public static boolean implementationOf(final String clazz, final String inter) throws ClassNotFoundException {
        return implementationOf(lookupClass(clazz), lookupClass(inter));
    }
    
    public static boolean instanceOf(final JavaClass clazz, final JavaClass superclass) throws ClassNotFoundException {
        return clazz.instanceOf(superclass);
    }
    
    public static boolean instanceOf(final JavaClass clazz, final String superclass) throws ClassNotFoundException {
        return instanceOf(clazz, lookupClass(superclass));
    }
    
    public static boolean instanceOf(final String clazz, final JavaClass superclass) throws ClassNotFoundException {
        return instanceOf(lookupClass(clazz), superclass);
    }
    
    public static boolean instanceOf(final String clazz, final String superclass) throws ClassNotFoundException {
        return instanceOf(lookupClass(clazz), lookupClass(superclass));
    }
    
    public static JavaClass lookupClass(final Class<?> clazz) throws ClassNotFoundException {
        return Repository.repository.loadClass(clazz);
    }
    
    public static JavaClass lookupClass(final String className) throws ClassNotFoundException {
        return Repository.repository.loadClass(className);
    }
    
    public static ClassPath.ClassFile lookupClassFile(final String className) {
        try (ClassPath path = Repository.repository.getClassPath()) {
            if (path == null) {
                return null;
            }
            return path.getClassFile(className);
        }
        catch (final IOException e) {
            return null;
        }
    }
    
    public static void removeClass(final JavaClass clazz) {
        Repository.repository.removeClass(clazz);
    }
    
    public static void removeClass(final String clazz) {
        Repository.repository.removeClass(Repository.repository.findClass(clazz));
    }
    
    public static void setRepository(final org.apache.bcel.util.Repository rep) {
        Repository.repository = rep;
    }
    
    static {
        Repository.repository = SyntheticRepository.getInstance();
    }
}
